/*
  h_file.h   Nov98  JS  ---  please look at h_file.c for more infos
  
*/
#ifndef _H_FILE_H
#define _H_FILE_H

// #include "config.h"  removed 2018.01
#include "defs.h"
#include "modeldef.h"   /* 2018.01 AddSS, but also dflt Nw NN Nq + config.h */
#include "hilbert.h" /* tbase, hbuf, thxy */
// #include "array_m.h" /* tvec=scplx */

/* 2019-01-16 HRMAX HR_TYPE BY_TYPE XY_TYPE XY_FLAG NAH=AHEAD NZXMAX HBLen ...
 * ... Hsize, struct thxy { nz[HBLen]; }  moved to hilbert.h */

#ifndef B_NUM
#error "we need B_NUM here defined in block.h"
#endif

extern int h_error;   /* set on write-error */
extern int h_state[B_NUM];    /* 0=closed, 1=ropen, 2=wopen */  


#if HRMAX>0 /* 2019-01 from hilbert.h, table of indexed diff. H-entries */
 /* table for 16bit(HR_SIZE) index to Hamilton-entries, one per thread */
struct s_hr {
 int  len; /* num entries, 2019-04: fix false sharing hbuf[B_NUM] */
 int  diag_len;  /* most entries are diag terms, check with this */
 cplx rr[HRMAX]; /* indexed different matrix entries */
};
extern struct s_hr hr[B_NUM]; /* h_file.c, 2019-04 avoid false sharing */
#endif

int h_ropen(int block);
int h_wopen(int block);
int h_rclose(int block);
int h_wclose(int block);
struct thxy *h_read(struct thxy *thb, size_t len, int block);

/* store/read H-element, block, column=xy+Flag_next_line, value */
/* void h_put(int block, ULong  xx, ULong  xy, cplx  r); */
/* void h_get(int block, ULong *xx, ULong *xy, cplx *r); */
size_t my_fread( char *ptr, size_t size, size_t nmemb, int block);
size_t my_fwrite( void *ptr, size_t size, size_t nmemb, int block);
extern int h_state[B_NUM];    /* 0=closed, 1=ropen, 2=wopen */
void err_fulltable();

void ini_thxy(ULong n1);
/* if vvv outut info */
void h_checkpoint(int vvv);
void h_restore(int vvv);
#endif
